
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Win32线程同步内核对象的比较 / 憋错料</title>

    <meta name="description" content="Win32线程同步内核对象的比较 X86处理器上用户层到内核层的转换要花费600个CPU指令周期 临界区(关键代码段)不是内核对象 但当访问被占用的资源时会使用内核资源 功能同互斥但不可跨进程 (以上引用自:http://www.dewen.org/q/9561) WIN32内核对象都是由HANDLE操控 信号量(Semaphore) wait函数族使访问计数递减 当且仅当访问计数0时无信号 ReleaseSemaphore递增访问计数 互斥(Mutex) 有且仅有1个访问计数的信号量(二元信号量binary semaphore">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Win32线程同步内核对象的比较</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>X86处理器上用户层到内核层的转换要花费600个CPU指令周期</p>
<p>临界区(关键代码段)不是内核对象 但当访问被占用的资源时会使用内核资源 功能同互斥但不可跨进程</p>
<p>(以上引用自:http://www.dewen.org/q/9561)</p>
<p>WIN32内核对象都是由HANDLE操控</p>
<p>信号量(Semaphore)</p>
<p>wait函数族使访问计数递减</p>
<p>当且仅当访问计数0时无信号</p>
<p>ReleaseSemaphore递增访问计数</p>
<p>互斥(Mutex)</p>
<p>有且仅有1个访问计数的信号量(二元信号量binary semaphore)</p>
<p>wait函数族使无信号(原理同信号量 访问计数为0)</p>
<p>ReleaseMutex使其有信号(解除阻塞)</p>
<p>事件(Event)</p>
<p>自动复位事件就是互斥</p>
<p>手动复位事件由用户控制ResetEvent和SetEvent的配合</p>
<p>wait函数族使无信号</p>
<p>SetEvent使其有信号(解除阻塞)</p>
<p><P>Win32线程同步内核对象的比较</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-22 07:02:08 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/line/" title="line">line</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.biecuoliao.com/tag/size/" title="size">size</a>, <a href="https://www.biecuoliao.com/tag/res/" title="res">res</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Win32线程同步内核对象的比较的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e9nP50.html" rel="bookmark">线程同步&mdash;&mdash;内核对象实现线程同步&mdash;&mdash;信号量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 /* 2 3 信号量内核对象 4 信号量与其它内核量相同,包含一个使用计数,除此之外还包含两个量. 5 一个最大资源计数和一个当前资源计数. 6 信号量规则如下: 7 如果当前资源计数大于0,那么信号量处于触发状态. 8 如果当前资源计数等于0,那么信号量处于未触发状态. 9 系统绝不会让当前资源计数变为负数. 10 当前资源计数绝不会大于最大资源计数. 11 12 下面我们看一下信号量的创建函数 13 HANDLE CreateSemaphore( 14 LPSECURITY_ATTRIB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoRKNx4.html" rel="bookmark">线程同步&mdash;&mdash;内核对象实现线程同步&mdash;&mdash;事件内核对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 事件内核对象 2 3 事件类型对象有两种不同类型,手动重置和自动重置 4 手动重置:当一个手动重置对象被触发时候,等待该对象的所有线程变为可调度. 5 自动重置:当一个自动重置对象被触发时,只有一个等待该事件的线程会变为可调度 6 7 下面是一个创建事件内核对象的函数: 8 HANDLE CreateEvent( 9 LPSECURITY_ATTRIBUTES lpEventAttributes, 10 BOOL bManualReset, 11 BOOL bInitialState, 12			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OXAPZ4.html" rel="bookmark">线程同步&mdash;&mdash;内核对象实现线程同步&mdash;&mdash;可等待计时器内核对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 可等待计时器 2 可等待计时器是这样一种内核对象,他们会在某个指定的时间触发或每隔一段时间触发一次. 5 下面我们来介绍一下创建可等待计时器函数: 6 7 HANDLE CreateWaitableTimer( 8 LPSECURITY_ATTRIBUTES lpTimerAttributes, 9 BOOL bManualReset, 10 LPCSTR lpTimerName ); 11 第一.三个参数我想我也不用介绍了哈,这是创建内核对象基本都会有的参数. 12 第二个参数bManua			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzXRok3.html" rel="bookmark">线程同步&mdash;&mdash;内核对象实现线程同步&mdash;&mdash;等待函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 对于内核对象实现线程同步,不得不提三点: 2 1)大多数内核对象既有触发也有未触发两个状态 3 比如:进程.线程.作业.文件流.事件.可等待的计时器.信号量.互斥量 4 2)等待函数:等待函数使线程自愿进入等待状态,直到指定的内核对象变为触发状态为止, 5 说道等待我们最喜欢不过了,因为这样不会浪费我们宝贵的CPU时间. 6 3)对于自动重置对象来说,当对象被触发时,函数会自动检测到(手动重置对象为触发是,函数也能检测到), 7 并开始执行,但是在函数会在返回之前使事件变为非触发状态. 8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MB1WJj4.html" rel="bookmark">线程与内核对象的同步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				线程与内核对象的同步内核对象可以处于已通知或未通知状体进程,线程,作业,文件,控制台输入,文件修改,事件,可等待定时器 等待函数DWORD WaitForSingleObject(HANDLE hobject, DWORD dwMilliseconds); 同时查看若干个内核对象已通知状体DWORD WaitForMultipleObjects(DWORD dwCount,CONST HANDLE* phObjects,BOOL fWaitAll,DWORD dwMilliseconds);dw			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vExpg0.html" rel="bookmark">Win32 - 线程同步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				线程的同步可分用户模式的线程同步和内核对象的线程同步两大类. 用户模式中线程的同步方法主要有原子访问和临界区等方法.其特点是同步速度特别快,适合于对线程运行速度有严格要求的场合. 内核对象的线程同步则主要由事件.等待定时器.信号量以及信号灯等内核对象构成.由于这种同步机制使用了内核对象,使用时必须将线程从用户模式切换到内核模式,而这种转换一般要耗费近千个CPU周期,因此同步速度较慢,但在适用性上却要远优于用户模式的线程同步方式. 在WIN32中,同步机制主要有以下几种: (1)事件(Event)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEqmNRM.html" rel="bookmark">Windows API学习---线程与内核对象的同步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 若干种内核对象,包括进程,线程和作业.可以将所有这些内核对象用于同步目的.对于线程同步来说,这些内核对象中的每种对象都可以说是处于已通知或未通知的状态之中.这种状态的切换是由Microsoft为每个对象建立的一套规则来决定的.例如,进程内核对象总是在未通知状态中创建的.当进程终止运行时,操作系统自动使该进程的内核对象处于已通知状态.一旦进程内核对象得到通知,它将永远保持这种状态,它的状态永远不会改为未通知状态. 当进程正在运行的时候,进程内核对象处于未通知状态,当进程终止运行的时候,它就变			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OQqL7M.html" rel="bookmark">线程与内核对象的同步-2</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				等待定时器内核事件CreateWaitableTimer(PSECURITY_ATTRIBUTES psa,BOOL fManualReset,PCTSTR pszName);进程可以获得它自己的与进程相关的现有等待定时器的句柄.HANDLE OpenWaitableTimer(DWORD dwDesiredAccess,BOOL bInheritHandle,PCTSTR pszName); 等待定时器对象总是在未通知状态中创建,必须调用SetWaitableTimer函数来告诉定时器你想在何			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jLj8W4.html" rel="bookmark">多线程实现线程同步&mdash;&mdash;事件对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				事件对象是指在程序中使用内核对象的有无信号状态实现线程的同步. 1.使用API函数操作事件对象 API函数为CreateEvent: 函数原型为: HANDLE CreateEvent( LPSECURITY_ATTRIBUTES lpEventAttributes, // SD BOOL bManualReset, // reset type BOOL bInitialState, // initial state LPCTSTR lpName // object name); 参数lpEve			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPZm63.html" rel="bookmark" class="title">使用事务码DBCO实现SAP链接外部数据库以及读取例程</a>
					<div>
						一.链接SQLServer数据库 执行事务码DBCO,点新条目按钮,填写如下图所示信息 这里的连接信息很接近 Sql Server 的连接字符串,但是参数名略有不同.指定主机IP.数据库名即可. 二. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RxE94.html" rel="bookmark" class="title">剑指offer（纪念版）读书笔记【实时更新】</a>
					<div>
						C++ 1.STL的vector每次扩充容量,新容量是前一次的两倍. 2.32位机指针大小为4个字节,64位机指针大小为8个字节. 3.当数组作为函数参数传递时,数组会自动退化成同类型指针. 4. & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P475290.html" rel="bookmark" class="title">&lbrack;android&rsqb;ShareSDK&mdash;&mdash;内容分享和短信验证</a>
					<div>
						前言 新版本号ShareSDK的分享和短信验证,按官网的文档,都须要加入一个&lt;Activity&gt;&lt;/Activity&gt;标签,而分享和短息验证的这个标签内容都一样.会冲突. 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQOdn3.html" rel="bookmark" class="title">戴尔dell R720服务器添加cpu和内存条注意事项！</a>
					<div>
						最近公司到了10台服务器,要求是给每台服务器添加1个cpu和8根16G内存条,添加完成之后每台服务器就是2个cpu和8根16G内存条(原来服务器上的2根8G内存条拔掉). 装挡板和上架服务器就不说了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5mRnM.html" rel="bookmark" class="title">Linux内核调试技术&mdash;&mdash;jprobe使用与实现</a>
					<div>
						前一篇博文介绍了kprobes的原理与kprobe的使用与实现方式,本文介绍kprobes中的第二种探测技术jprobe,它基于kprobe实现,不能在函数的任意位置插入探测点,只能在函数的入口处探测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvjDk3.html" rel="bookmark" class="title">yum安装tomcat</a>
					<div>
						http://www.cnblogs.com/liaolongjun/p/5638740.html http://www.awspack.com/os/linux/yum-install-tomcat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eq8ya0.html" rel="bookmark" class="title">写程序判断系统是大端序还是小端序</a>
					<div>
						大端是高位字节先存储(低地址) 小端是低位字节先存储(低地址) 网络字节序是大端的,也就是高位字节先传输 而int--char的强制转换,是将低地址的数值截断赋给char,利用这个准则可以判断系统是大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXzyX3.html" rel="bookmark" class="title">&period;NET中的动态编译</a>
					<div>
						http://www.cnblogs.com/zlgcool/archive/2008/10/12/1309616.html 在开始之前,先熟悉几个类及部分属性.方法:CSharpCodeProvid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8oLyM.html" rel="bookmark" class="title">Python爬虫抓取煎蛋&lpar;jandan&period;net&rpar;无聊图</a>
					<div>
						1 #!/usr/bin/python 2 #encoding:utf-8 3 ''' 4 @python 3.6.1 5 @author: [email protected] 6 @create d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXKXwM.html" rel="bookmark" class="title">系统架构设计&mdash;&mdash;学习篇之类的设计&lpar;UML&rpar;</a>
					<div>
						概述 &quot;编程是一门技术,更加是一门艺术,不能只满足于写完代码运行结果正确久完事,时常考虑如何让代码更加简练,更加容易维护,容易扩展和服用,只有这样才可以真正得到提高.写出优雅的代码真的是一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQmx80.html" rel="bookmark" class="title">HDU 5371 Hotaru&amp;&num;39&semi;s problem manacher&plus;（线段树or set）</a>
					<div>
						题意,给定一个100000 的串,求他一个子串,使得将子串分成三部分有后,第一部分=第三部分,第一部分与第二部分对称(回文) 首先我们需要处理出以i为轴的回文串的两端,这个事情可以用Manacher算 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qve294.html" rel="bookmark" class="title">sqlite3自增key设定&lpar;创建自增字段&rpar;</a>
					<div>
						在用sqlite设计表时,每个表都有一个自己的整形id值作为主键,其实可以不指定这 么一个id值,sqlite内部本来就会为每个表加上一个 rowid,这个rowid可以当成一个隐含的字段使用,但是由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mox6VQ0.html" rel="bookmark" class="title">使用python制作二维码</a>
					<div>
						python-qrcode是个用来生成二维码图片的第三方模块,主要依赖的是 PIL 模块和 qrcode 库.(PIL模块只支持python2.7及以下版本,python3之后无法使用,官方推荐pyt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5Dk90.html" rel="bookmark" class="title">3 Sum Closest 解答</a>
					<div>
						Question Given an array S of n integers, find three integers in S such that the sum is closest to a  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglleO0.html" rel="bookmark" class="title">Python狂练-1</a>
					<div>
						有四个数字:1.2.3.4,能组成多少个互不相同且无重复数字的三位数?各是多少? 把数字变成字符再把字符拼起来: #!/usr/bin/env python # -*- coding:utf-8 -* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7XGWM.html" rel="bookmark" class="title">linux kernel4版本以上内核升级测试</a>
					<div>
						已经将centos6升级成 kenrel 4.1.4,uname -an一下 Linux localhost.localdomain 4.1.4-1.el7.elrepo.x86_64 #1 SMP  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dR5xZ4.html" rel="bookmark" class="title">Boost timer 学习笔记</a>
					<div>
						今天开始看&lt;Boost程序库完全开发指南:深入C++&quot;准&quot;标准库(第3版)&gt;一书.我用的是boost 1.57,而书上使用的是boost 1.43左右.原以为差距不大, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvz7A3.html" rel="bookmark" class="title">Another option for file sharing（转）</a>
					<div>
						原文地址  https://security.googleblog.com/2017/02/another-option-for-file-sharing.html Another option fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBZr10.html" rel="bookmark" class="title">蛤斯凯尔耐听耐</a>
					<div>
						-- Problem 1 -- (*) Find the last element of a list. -- (Note that the Lisp transcription of this pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQJx70.html" rel="bookmark" class="title">JS计算网页停留时间代码</a>
					<div>
						JS计算网页停留时间的代码. &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.01 Transitional//EN&quot; &quot;htt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
